#!/bin/perl
#################################################################################
# Created       : Martin Foster
# Modified      : 12/17/2001
#################################################################################
#
# Colours - Script part of Webchat designed to list all colours
# Copyright (C) 2000-2002  Martin Foster
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
# Author of this script can be contacted at the following:
#       E-Mail  : martin@ethereal-realms.org
#       Address : 204 - 817, 5th Street NE
#                 Calgary, Alberta
#                 T2E 3W9
#
#################################################################################

use CGI qw(:standard);						# Common gateway interface
use CGI::Carp qw(fatalsToBrowser);				# CGI Error logs
use strict;							# Strict variable enforcement

use Ethereal::Database;						# Database handler
use Ethereal::Login;						# Login functionality
use Ethereal::Param;						# Parameter control
use Ethereal::Option;						# Option handling


#################################################################################
# Data Members
#################################################################################
my $cgi;							# Common gateway interface handle
my $database;							# Database handle
my $option;							
my $param;							# Parameter handle
my $table;							# Table handler

my $count;							# Counter
my $size;							# Size of array

my @names;							# Colour names
my @codes;							# Colour codes

my %realm;							# Realm hash


#################################################################################
# Program Area
#################################################################################

	# Initial handles
	$cgi      = new CGI;
	$database = new Ethereal::Database();
	$param    = new Ethereal::Param();
	$option   = new Ethereal::Option();
	$table    = new Ethereal::Table($cgi);

	# Connect and fetch
	$database->Connect();
	$param->GetParam($cgi);

	# Connect with has
	$database->GetHashRealm(\%realm);


	# Retreive lists
	$option->Split(\@names, $realm{'OptTextColour'}); 
	$option->Split(\@codes, $realm{'OptTextColourHex'}); 

	# Get size
	$size = @names;


	# Document header
	print $cgi->header();
	print $database->FetchRealmHeader($param->{'ROOM'});

	# Table top
	$table->MakeTop();
	
	# Cycle through
	for ($count = 0; $count < $size; $count++)
	{
		# Display information
		$table->MakeValid("<B><FONT COLOR=\"$codes[$count]\">$names[$count]</FONT></B>", "<FONT COLOR=\"$codes[$count]\">$codes[$count]</FONT>");
	}

	# Table bottom
	$table->MakeBottom();

	# Document footer
	print $database->FetchRealmFooter($param->{'ROOM'});
